workstation/ansible-setup.sh

93 lines
2.1 KiB
Bash
Raw Normal View History

2021-02-20 21:29:45 +00:00
#!/bin/bash
2021-02-19 23:18:33 +00:00
# Copyright 2021 Anthony Perkins
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
2022-07-18 09:37:09 +00:00
if [ x$1 != x ]; then
2022-07-18 09:30:01 +00:00
install_path=$1
if [ $(id -u) -eq 0 ]; then
bin_path=/usr/local/bin
else
bin_path="$HOME/.local/bin"
fi
elif [ $(id -u) -eq 0 ]; then
install_path=/opt/ansible
bin_path=/usr/local/bin
else
install_path="$HOME/opt/ansible"
2022-07-17 18:50:44 +00:00
bin_path="$HOME/.local/bin"
fi
2022-07-18 09:37:09 +00:00
echo "Install path: $install_path"
echo "Bin path: $bin_path"
2021-02-19 23:18:33 +00:00
pipinstall () {
2022-07-18 09:45:50 +00:00
if [ -r /etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem ]; then
cafile="--cert /etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem"
else
cafile=""
fi
./bin/pip $cafile install --upgrade $1
2021-02-19 23:18:33 +00:00
}
2021-02-19 23:42:10 +00:00
create_link () {
2021-08-31 20:51:24 +00:00
ln -srf "$install_path/bin/$1" "$bin_path/$1"
2021-02-19 23:42:10 +00:00
}
py3cmd="$(command -v python3)"
if [ ! -x "$py3cmd" ]; then
echo "python3 not found"
2021-06-08 13:42:02 +00:00
exit 1
2021-02-19 23:42:10 +00:00
else
2022-07-18 09:37:09 +00:00
echo "Python3 found: $py3cmd"
2021-02-19 23:42:10 +00:00
fi
2021-06-09 10:39:24 +00:00
if ! $($py3cmd -c "import venv" 2> /dev/null); then
echo "Python3 venv module missing. Try installing python3-venv package."
exit 1
fi
if ! $($py3cmd -c "import ensurepip" 2> /dev/null); then
echo "Python3 ensurepip module missing. Try installing python3-venv package."
2021-05-26 14:39:56 +00:00
exit 1
fi
2021-03-22 22:39:11 +00:00
if [ ! -d "$install_path" ]; then
python3 -m venv "$install_path" || exit 1
2021-02-19 23:18:33 +00:00
fi
pushd "$install_path"
2021-02-19 23:18:33 +00:00
pipinstall wheel
2021-03-18 12:56:03 +00:00
pipinstall pip
2021-02-19 23:18:33 +00:00
pipinstall ansible
popd
2021-02-19 23:42:10 +00:00
if [ ! -d "$bin_path" ]; then
mkdir "$bin_path"
2021-02-20 21:29:45 +00:00
fi
2021-02-19 23:42:10 +00:00
for command in \
ansible \
ansible-config \
ansible-connection \
ansible-console \
ansible-doc \
ansible-galaxy \
ansible-inventory \
ansible-playbook \
ansible-pull \
ansible-test \
ansible-vault; do
create_link $command
done